# udatpg.h File Reference

C API: Wrapper for DateTimePatternGenerator (unicode/dtptngen.h). More...

`#include "unicode/utypes.h"`
`#include "unicode/uenum.h"`

Go to the source code of this file.

## Typedefs
typedef void * | UDateTimePatternGenerator
| Opaque type for a date/time pattern generator object.
## Enumerations
enum | UDateTimePatternField { UDATPG_ERA_FIELD, UDATPG_YEAR_FIELD, UDATPG_QUARTER_FIELD, UDATPG_MONTH_FIELD, UDATPG_WEEK_OF_YEAR_FIELD, UDATPG_WEEK_OF_MONTH_FIELD, UDATPG_WEEKDAY_FIELD, UDATPG_DAY_OF_YEAR_FIELD, UDATPG_DAY_OF_WEEK_IN_MONTH_FIELD, UDATPG_DAY_FIELD, UDATPG_DAYPERIOD_FIELD, UDATPG_HOUR_FIELD, UDATPG_MINUTE_FIELD, UDATPG_SECOND_FIELD, UDATPG_FRACTIONAL_SECOND_FIELD, UDATPG_ZONE_FIELD, UDATPG_FIELD_COUNT }
| Field number constants for udatpg_getAppendItemFormats() and similar functions. More...
enum | UDateTimePatternConflict { UDATPG_NO_CONFLICT, UDATPG_BASE_CONFLICT, UDATPG_CONFLICT, UDATPG_CONFLICT_COUNT }
| Status return values from udatpg_addPattern(). More...
## Functions
UDateTimePatternGenerator * | udatpg_open (const char *locale, UErrorCode *pErrorCode)
| Open a generator according to a given locale.
UDateTimePatternGenerator * | udatpg_openEmpty (UErrorCode *pErrorCode)
| Open an empty generator, to be constructed with udatpg_addPattern(.
void | udatpg_close (UDateTimePatternGenerator *dtpg)
| Close a generator.
UDateTimePatternGenerator * | udatpg_clone (const UDateTimePatternGenerator *dtpg, UErrorCode *pErrorCode)
| Create a copy pf a generator.
int32_t | udatpg_getBestPattern (UDateTimePatternGenerator *dtpg, const UChar *skeleton, int32_t length, UChar *bestPattern, int32_t capacity, UErrorCode *pErrorCode)
| Get the best pattern matching the input skeleton.
int32_t | udatpg_getSkeleton (UDateTimePatternGenerator *dtpg, const UChar *pattern, int32_t length, UChar *skeleton, int32_t capacity, UErrorCode *pErrorCode)
| Get a unique skeleton from a given pattern.
int32_t | udatpg_getBaseSkeleton (UDateTimePatternGenerator *dtpg, const UChar *pattern, int32_t length, UChar *baseSkeleton, int32_t capacity, UErrorCode *pErrorCode)
| Get a unique base skeleton from a given pattern.
UDateTimePatternConflict | udatpg_addPattern (UDateTimePatternGenerator *dtpg, const UChar *pattern, int32_t patternLength, UBool override, UChar *conflictingPattern, int32_t capacity, int32_t *pLength, UErrorCode *pErrorCode)
| Adds a pattern to the generator.
void | udatpg_setAppendItemFormat (UDateTimePatternGenerator *dtpg, UDateTimePatternField field, const UChar *value, int32_t length)
| An AppendItem format is a pattern used to append a field if there is no good match.
const UChar * | udatpg_getAppendItemFormat (const UDateTimePatternGenerator *dtpg, UDateTimePatternField field, int32_t *pLength)
| Getter corresponding to setAppendItemFormat.
void | udatpg_setAppendItemName (UDateTimePatternGenerator *dtpg, UDateTimePatternField field, const UChar *value, int32_t length)
| Set the name of field, eg "era" in English for ERA.
const UChar * | udatpg_getAppendItemName (const UDateTimePatternGenerator *dtpg, UDateTimePatternField field, int32_t *pLength)
| Getter corresponding to setAppendItemNames.
void | udatpg_setDateTimeFormat (const UDateTimePatternGenerator *dtpg, const UChar *dtFormat, int32_t length)
| The date time format is a message format pattern used to compose date and time patterns.
const UChar * | udatpg_getDateTimeFormat (const UDateTimePatternGenerator *dtpg, int32_t *pLength)
| Getter corresponding to setDateTimeFormat.
void | udatpg_setDecimal (UDateTimePatternGenerator *dtpg, const UChar *decimal, int32_t length)
| The decimal value is used in formatting fractions of seconds.
const UChar * | udatpg_getDecimal (const UDateTimePatternGenerator *dtpg, int32_t *pLength)
| Getter corresponding to setDecimal.
int32_t | udatpg_replaceFieldTypes (UDateTimePatternGenerator *dtpg, const UChar *pattern, int32_t patternLength, const UChar *skeleton, int32_t skeletonLength, UChar *dest, int32_t destCapacity, UErrorCode *pErrorCode)
| Adjusts the field types (width and subtype) of a pattern to match what is in a skeleton.
UEnumeration * | udatpg_openSkeletons (const UDateTimePatternGenerator *dtpg, UErrorCode *pErrorCode)
| Return a UEnumeration list of all the skeletons in canonical form.
UEnumeration * | udatpg_openBaseSkeletons (const UDateTimePatternGenerator *dtpg, UErrorCode *pErrorCode)
| Return a UEnumeration list of all the base skeletons in canonical form.
const UChar * | udatpg_getPatternForSkeleton (const UDateTimePatternGenerator *dtpg, const UChar *skeleton, int32_t skeletonLength, int32_t *pLength)
| Get the pattern corresponding to a given skeleton.

## Detailed Description

C API: Wrapper for DateTimePatternGenerator (unicode/dtptngen.h).

UDateTimePatternGenerator provides flexible generation of date format patterns, like "yy-MM-dd". The user can build up the generator by adding successive patterns. Once that is done, a query can be made using a "skeleton", which is a pattern which just includes the desired fields and lengths. The generator will return the "best fit" pattern corresponding to that skeleton.

The main method people will use is udatpg_getBestPattern, since normally UDateTimePatternGenerator is pre-built with data from a particular locale. However, generators can be built directly from other data as well.

Issue: may be useful to also have a function that returns the list of fields in a pattern, in order, since we have that internally. That would be useful for getting the UI order of field elements.

Definition in file udatpg.h.

## Typedef Documentation

typedef void* UDateTimePatternGenerator

Opaque type for a date/time pattern generator object.

Stable:
  ICU 3.8

Definition at line 44 of file udatpg.h.

## Enumeration Type Documentation

enum UDateTimePatternConflict

Status return values from udatpg_addPattern().

Stable:
  ICU 3.8

Enumerator:

  UDATPG_NO_CONFLICT | Stable: ICU 3.8
  UDATPG_BASE_CONFLICT | Stable: ICU 3.8
  UDATPG_CONFLICT | Stable: ICU 3.8
  UDATPG_CONFLICT_COUNT | Stable: ICU 3.8

Definition at line 93 of file udatpg.h.

enum UDateTimePatternField

Field number constants for udatpg_getAppendItemFormats() and similar functions.

These constants are separate from UDateFormatField despite semantic overlap because some fields are merged for the date/time pattern generator.

Stable:
  ICU 3.8

Enumerator:

  UDATPG_ERA_FIELD | Stable: ICU 3.8
  UDATPG_YEAR_FIELD | Stable: ICU 3.8
  UDATPG_QUARTER_FIELD | Stable: ICU 3.8
  UDATPG_MONTH_FIELD | Stable: ICU 3.8
  UDATPG_WEEK_OF_YEAR_FIELD | Stable: ICU 3.8
  UDATPG_WEEK_OF_MONTH_FIELD | Stable: ICU 3.8
  UDATPG_WEEKDAY_FIELD | Stable: ICU 3.8
  UDATPG_DAY_OF_YEAR_FIELD | Stable: ICU 3.8
  UDATPG_DAY_OF_WEEK_IN_MONTH_FIELD | Stable: ICU 3.8
  UDATPG_DAY_FIELD | Stable: ICU 3.8
  UDATPG_DAYPERIOD_FIELD | Stable: ICU 3.8
  UDATPG_HOUR_FIELD | Stable: ICU 3.8
  UDATPG_MINUTE_FIELD | Stable: ICU 3.8
  UDATPG_SECOND_FIELD | Stable: ICU 3.8
  UDATPG_FRACTIONAL_SECOND_FIELD | Stable: ICU 3.8
  UDATPG_ZONE_FIELD | Stable: ICU 3.8
  UDATPG_FIELD_COUNT | Stable: ICU 3.8

Definition at line 52 of file udatpg.h.

## Function Documentation

UDateTimePatternConflict udatpg_addPattern | ( | UDateTimePatternGenerator * | dtpg,
|  | const UChar * | pattern,
|  | int32_t | patternLength,
|  | UBool | override,
|  | UChar * | conflictingPattern,
|  | int32_t | capacity,
|  | int32_t * | pLength,
|  | UErrorCode * | pErrorCode |
| ) |  |  |

Adds a pattern to the generator.

If the pattern has the same skeleton as an existing pattern, and the override parameter is set, then the previous value is overriden. Otherwise, the previous value is retained. In either case, the conflicting status is set and previous vale is stored in conflicting pattern.

Note that single-field patterns (like "MMM") are automatically added, and don't need to be added explicitly!

Parameters:

  | dtpg | a pointer to UDateTimePatternGenerator.
  | pattern | input pattern, such as "dd/MMM"
  | patternLength | the length of pattern.
  | override | When existing values are to be overridden use true, otherwise use false.
  | conflictingPattern | Previous pattern with the same skeleton.
  | capacity | the capacity of conflictingPattern.
  | pLength | a pointer to the length of conflictingPattern.
  | pErrorCode | a pointer to the UErrorCode which must not indicate a failure before the function call.

Returns:
  conflicting status. The value could be UDATPG_NO_CONFLICT, UDATPG_BASE_CONFLICT or UDATPG_CONFLICT.

Stable:
  ICU 3.8

UDateTimePatternGenerator* udatpg_clone | ( | const UDateTimePatternGenerator * | dtpg,
|  | UErrorCode * | pErrorCode |
| ) |  |  |

Create a copy pf a generator.

Parameters:

  | dtpg | a pointer to UDateTimePatternGenerator to be copied.
  | pErrorCode | a pointer to the UErrorCode which must not indicate a failure before the function call.

Returns:
  a pointer to a new UDateTimePatternGenerator.

Stable:
  ICU 3.8

void udatpg_close | ( | UDateTimePatternGenerator * | dtpg | ) |

Close a generator.

Parameters:

  | dtpg | a pointer to UDateTimePatternGenerator.

Stable:
  ICU 3.8

const UChar* udatpg_getAppendItemFormat | ( | const UDateTimePatternGenerator * | dtpg,
|  | UDateTimePatternField | field,
|  | int32_t * | pLength |
| ) |  |  |

Getter corresponding to setAppendItemFormat.

Values below 0 or at or above UDATPG_FIELD_COUNT are illegal arguments.

Parameters:

  | dtpg | A pointer to UDateTimePatternGenerator.
  | field | UDateTimePatternField, such as UDATPG_ERA_FIELD
  | pLength | A pointer that will receive the length of appendItemFormat.

Returns:
  appendItemFormat for field.

Stable:
  ICU 3.8

const UChar* udatpg_getAppendItemName | ( | const UDateTimePatternGenerator * | dtpg,
|  | UDateTimePatternField | field,
|  | int32_t * | pLength |
| ) |  |  |

Getter corresponding to setAppendItemNames.

Values below 0 or at or above UDATPG_FIELD_COUNT are illegal arguments.

Parameters:

  | dtpg | a pointer to UDateTimePatternGenerator.
  | field | UDateTimePatternField, such as UDATPG_ERA_FIELD
  | pLength | A pointer that will receive the length of the name for field.

Returns:
  name for field

Stable:
  ICU 3.8

int32_t udatpg_getBaseSkeleton | ( | UDateTimePatternGenerator * | dtpg,
|  | const UChar * | pattern,
|  | int32_t | length,
|  | UChar * | baseSkeleton,
|  | int32_t | capacity,
|  | UErrorCode * | pErrorCode |
| ) |  |  |

Get a unique base skeleton from a given pattern.

This is the same as the skeleton, except that differences in length are minimized so as to only preserve the difference between string and numeric form. So for example, both "MMM-dd" and "d/MMM" produce the skeleton "MMMd" (notice the single d).

Note that this function uses a non-const UDateTimePatternGenerator: It uses a stateful pattern parser which is set up for each generator object, rather than creating one for each function call. Consecutive calls to this function do not affect each other, but this function cannot be used concurrently on a single generator object.

Parameters:

  | dtpg | a pointer to UDateTimePatternGenerator.
  | pattern | input pattern, such as "dd/MMM".
  | length | the length of pattern.
  | baseSkeleton | such as "Md"
  | capacity | the capacity of base skeleton.
  | pErrorCode | a pointer to the UErrorCode which must not indicate a failure before the function call.

Returns:
  the length of baseSkeleton.

Stable:
  ICU 3.8

int32_t udatpg_getBestPattern | ( | UDateTimePatternGenerator * | dtpg,
|  | const UChar * | skeleton,
|  | int32_t | length,
|  | UChar * | bestPattern,
|  | int32_t | capacity,
|  | UErrorCode * | pErrorCode |
| ) |  |  |

Get the best pattern matching the input skeleton.

It is guaranteed to have all of the fields in the skeleton.

Note that this function uses a non-const UDateTimePatternGenerator: It uses a stateful pattern parser which is set up for each generator object, rather than creating one for each function call. Consecutive calls to this function do not affect each other, but this function cannot be used concurrently on a single generator object.

Parameters:

  | dtpg | a pointer to UDateTimePatternGenerator.
  | skeleton | The skeleton is a pattern containing only the variable fields. For example, "MMMdd" and "mmhh" are skeletons.
  | length | the length of skeleton
  | bestPattern | The best pattern found from the given skeleton.
  | capacity | the capacity of bestPattern.
  | pErrorCode | a pointer to the UErrorCode which must not indicate a failure before the function call.

Returns:
  the length of bestPattern.

Stable:
  ICU 3.8

const UChar* udatpg_getDateTimeFormat | ( | const UDateTimePatternGenerator * | dtpg,
|  | int32_t * | pLength |
| ) |  |  |

Getter corresponding to setDateTimeFormat.

Parameters:

  | dtpg | a pointer to UDateTimePatternGenerator.
  | pLength | A pointer that will receive the length of the format

Returns:
  dateTimeFormat.

Stable:
  ICU 3.8

const UChar* udatpg_getDecimal | ( | const UDateTimePatternGenerator * | dtpg,
|  | int32_t * | pLength |
| ) |  |  |

Getter corresponding to setDecimal.

Parameters:

  | dtpg | a pointer to UDateTimePatternGenerator.
  | pLength | A pointer that will receive the length of the decimal string.

Returns:
  corresponding to the decimal point.

Stable:
  ICU 3.8

const UChar* udatpg_getPatternForSkeleton | ( | const UDateTimePatternGenerator * | dtpg,
|  | const UChar * | skeleton,
|  | int32_t | skeletonLength,
|  | int32_t * | pLength |
| ) |  |  |

Get the pattern corresponding to a given skeleton.

Parameters:

  | dtpg | a pointer to UDateTimePatternGenerator.
  | skeleton |
  | skeletonLength | pointer to the length of skeleton.
  | pLength | pointer to the length of return pattern.

Returns:
  pattern corresponding to a given skeleton.

Stable:
  ICU 3.8

int32_t udatpg_getSkeleton | ( | UDateTimePatternGenerator * | dtpg,
|  | const UChar * | pattern,
|  | int32_t | length,
|  | UChar * | skeleton,
|  | int32_t | capacity,
|  | UErrorCode * | pErrorCode |
| ) |  |  |

Get a unique skeleton from a given pattern.

For example, both "MMM-dd" and "dd/MMM" produce the skeleton "MMMdd".

Note that this function uses a non-const UDateTimePatternGenerator: It uses a stateful pattern parser which is set up for each generator object, rather than creating one for each function call. Consecutive calls to this function do not affect each other, but this function cannot be used concurrently on a single generator object.

Parameters:

  | dtpg | a pointer to UDateTimePatternGenerator.
  | pattern | input pattern, such as "dd/MMM".
  | length | the length of pattern.
  | skeleton | such as "MMMdd"
  | capacity | the capacity of skeleton.
  | pErrorCode | a pointer to the UErrorCode which must not indicate a failure before the function call.

Returns:
  the length of skeleton.

Stable:
  ICU 3.8

UDateTimePatternGenerator* udatpg_open | ( | const char * | locale,
|  | UErrorCode * | pErrorCode |
| ) |  |  |

Open a generator according to a given locale.

Parameters:

  | locale |
  | pErrorCode | a pointer to the UErrorCode which must not indicate a failure before the function call.

Returns:
  a pointer to UDateTimePatternGenerator.

Stable:
  ICU 3.8

UEnumeration* udatpg_openBaseSkeletons | ( | const UDateTimePatternGenerator * | dtpg,
|  | UErrorCode * | pErrorCode |
| ) |  |  |

Return a UEnumeration list of all the base skeletons in canonical form.

Parameters:

  | dtpg | a pointer to UDateTimePatternGenerator.
  | pErrorCode | a pointer to the UErrorCode which must not indicate a failure before the function call.

Returns:
  a UEnumeration list of all the base skeletons The caller must close the object.

Stable:
  ICU 3.8

UDateTimePatternGenerator* udatpg_openEmpty | ( | UErrorCode * | pErrorCode | ) |

Open an empty generator, to be constructed with udatpg_addPattern(.

..) etc.

Parameters:

  | pErrorCode | a pointer to the UErrorCode which must not indicate a failure before the function call.

Returns:
  a pointer to UDateTimePatternGenerator.

Stable:
  ICU 3.8

UEnumeration* udatpg_openSkeletons | ( | const UDateTimePatternGenerator * | dtpg,
|  | UErrorCode * | pErrorCode |
| ) |  |  |

Return a UEnumeration list of all the skeletons in canonical form.

Call udatpg_getPatternForSkeleton() to get the corresponding pattern.

Parameters:

  | dtpg | a pointer to UDateTimePatternGenerator.
  | pErrorCode | a pointer to the UErrorCode which must not indicate a failure before the function call

Returns:
  a UEnumeration list of all the skeletons The caller must close the object.

Stable:
  ICU 3.8

int32_t udatpg_replaceFieldTypes | ( | UDateTimePatternGenerator * | dtpg,
|  | const UChar * | pattern,
|  | int32_t | patternLength,
|  | const UChar * | skeleton,
|  | int32_t | skeletonLength,
|  | UChar * | dest,
|  | int32_t | destCapacity,
|  | UErrorCode * | pErrorCode |
| ) |  |  |

Adjusts the field types (width and subtype) of a pattern to match what is in a skeleton.

That is, if you supply a pattern like "d-M H:m", and a skeleton of "MMMMddhhmm", then the input pattern is adjusted to be "dd-MMMM hh:mm". This is used internally to get the best match for the input skeleton, but can also be used externally.

Note that this function uses a non-const UDateTimePatternGenerator: It uses a stateful pattern parser which is set up for each generator object, rather than creating one for each function call. Consecutive calls to this function do not affect each other, but this function cannot be used concurrently on a single generator object.

Parameters:

  | dtpg | a pointer to UDateTimePatternGenerator.
  | pattern | Input pattern
  | patternLength | the length of input pattern.
  | skeleton |
  | skeletonLength | the length of input skeleton.
  | dest | pattern adjusted to match the skeleton fields widths and subtypes.
  | destCapacity | the capacity of dest.
  | pErrorCode | a pointer to the UErrorCode which must not indicate a failure before the function call.

Returns:
  the length of dest.

Stable:
  ICU 3.8

void udatpg_setAppendItemFormat | ( | UDateTimePatternGenerator * | dtpg,
|  | UDateTimePatternField | field,
|  | const UChar * | value,
|  | int32_t | length |
| ) |  |  |

An AppendItem format is a pattern used to append a field if there is no good match.

For example, suppose that the input skeleton is "GyyyyMMMd", and there is no matching pattern internally, but there is a pattern matching "yyyyMMMd", say "d-MM-yyyy". Then that pattern is used, plus the G. The way these two are conjoined is by using the AppendItemFormat for G (era). So if that value is, say "{0}, {1}" then the final resulting pattern is "d-MM-yyyy, G".

There are actually three available variables: {0} is the pattern so far, {1} is the element we are adding, and {2} is the name of the element.

This reflects the way that the CLDR data is organized.

Parameters:

  | dtpg | a pointer to UDateTimePatternGenerator.
  | field | UDateTimePatternField, such as UDATPG_ERA_FIELD
  | value | pattern, such as "{0}, {1}"
  | length | the length of value.

Stable:
  ICU 3.8

void udatpg_setAppendItemName | ( | UDateTimePatternGenerator * | dtpg,
|  | UDateTimePatternField | field,
|  | const UChar * | value,
|  | int32_t | length |
| ) |  |  |

Set the name of field, eg "era" in English for ERA.

These are only used if the corresponding AppendItemFormat is used, and if it contains a {2} variable.

This reflects the way that the CLDR data is organized.

Parameters:

  | dtpg | a pointer to UDateTimePatternGenerator.
  | field | UDateTimePatternField
  | value | name for the field.
  | length | the length of value.

Stable:
  ICU 3.8

void udatpg_setDateTimeFormat | ( | const UDateTimePatternGenerator * | dtpg,
|  | const UChar * | dtFormat,
|  | int32_t | length |
| ) |  |  |

The date time format is a message format pattern used to compose date and time patterns.

The default value is "{0} {1}", where {0} will be replaced by the date pattern and {1} will be replaced by the time pattern.

This is used when the input skeleton contains both date and time fields, but there is not a close match among the added patterns. For example, suppose that this object was created by adding "dd-MMM" and "hh:mm", and its datetimeFormat is the default "{0} {1}". Then if the input skeleton is "MMMdhmm", there is not an exact match, so the input skeleton is broken up into two components "MMMd" and "hmm". There are close matches for those two skeletons, so the result is put together with this pattern, resulting in "d-MMM h:mm".

Parameters:

  | dtpg | a pointer to UDateTimePatternGenerator.
  | dtFormat | message format pattern, here {0} will be replaced by the date pattern and {1} will be replaced by the time pattern.
  | length | the length of dtFormat.

Stable:
  ICU 3.8

void udatpg_setDecimal | ( | UDateTimePatternGenerator * | dtpg,
|  | const UChar * | decimal,
|  | int32_t | length |
| ) |  |  |

The decimal value is used in formatting fractions of seconds.

If the skeleton contains fractional seconds, then this is used with the fractional seconds. For example, suppose that the input pattern is "hhmmssSSSS", and the best matching pattern internally is "H:mm:ss", and the decimal string is ",". Then the resulting pattern is modified to be "H:mm:ss,SSSS"

Parameters:

  | dtpg | a pointer to UDateTimePatternGenerator.
  | decimal |
  | length | the length of decimal.

Stable:
  ICU 3.8